"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const deepmerge_1 = __importDefault(require("deepmerge"));
const createThemeProvider_1 = __importDefault(require("./createThemeProvider"));
const createWithTheme_1 = __importDefault(require("./createWithTheme"));
function createTheming(defaultTheme) {
    const ThemeContext = React.createContext(defaultTheme);
    const ThemeProvider = createThemeProvider_1.default(defaultTheme, ThemeContext);
    const withTheme = createWithTheme_1.default(ThemeContext);
    const useTheme = (overrides) => {
        const theme = React.useContext(ThemeContext);
        const result = React.useMemo(() => theme && overrides ? deepmerge_1.default(theme, overrides) : theme || overrides, [theme, overrides]);
        return result;
    };
    return {
        ThemeContext,
        ThemeProvider,
        withTheme,
        useTheme,
    };
}
exports.default = createTheming;
